package net.sf.sido;

import org.apache.commons.lang.Validate;

public class ParentLink {

	private final Object parent;
	private final String parentProperty;

	public ParentLink(Object parent, String parentProperty) {
		Validate.notNull(parent, "Parent is required");
		Validate.notEmpty(parentProperty, "Parent property is required");
		this.parent = parent;
		this.parentProperty = parentProperty;
	}

	public ParentLink changeParent(DataObject newParent) {
		return new ParentLink(newParent, parentProperty);
	}

	public Object getParent() {
		return parent;
	}

	public String getParentProperty() {
		return parentProperty;
	}

}
