package net.sf.sido.constraint;

import com.google.common.base.Predicate;

public class EnumConstraint<E extends Enum<E>> implements Predicate<String> {

	private final Class<E> enumClass;

	public EnumConstraint(Class<E> enumClass) {
		this.enumClass = enumClass;
	}

    public Class<E> getEnumClass() {
        return enumClass;
    }

    @Override
	public boolean apply(String input) {
		if (input != null) {
			try {
				// Tries to parse the value
				E e = Enum.valueOf(enumClass, input);
				// OK
				return (e != null);
			} catch (IllegalArgumentException ex) {
				return false;
			}
		} else {
			return true;
		}
	}

}
