package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.DataSchema;

import java.io.IOException;
import java.util.Map;

public class SimplePropertyAssembler extends AbstractPropertyAssembler {

	private final String type;

	public SimplePropertyAssembler(String name, String type) {
		super(name);
		this.type = type;
	}

    @Override
    public <T> void addProperty(DataFactory factory, PropertyAssemblerCallback callback, Map<String, DataSchema> schemas, Map<String,TypeDefinition> typeDefinitions, TypeDefinition definition, DataObject property) throws IOException {
		Class<T> cls = factory.getSimpleType(type);
		// Nullable
		boolean nullable = isNullable(property);
		// Constraint
		Predicate<T> constraint = readConstraint(factory, property);
		// Builder
		definition.getBuilder().addProperty(name, nullable, cls, constraint);
	}

}
