package net.sf.sido.support;

import net.sf.jstring.AbstractLocalizable;
import net.sf.jstring.Strings;
import net.sf.sido.DOException;
import net.sf.sido.ValidationError;

import java.util.Locale;

public class DefaultValidationError extends AbstractLocalizable implements ValidationError {

    private final String name;

    private final DOException error;

    public DefaultValidationError(String name, DOException error) {
        this.name = name;
        this.error = error;
    }

    @Override
    public DOException getError() {
        return this.error;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public String getLocalizedMessage(Strings strings, Locale locale) {
        return strings.get(locale, "sido.ValidationError", name, error);
    }
}
